Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:51 2008
FILE NAME: i.lpj_pftinout.f90
PROGRAM NAME: lpj_pftinout
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   137  vec  (   4): Vectorized array expression.
   139  vec  (   3): Unvectorized loop.
   139  vec  (  13): Overhead of loop division is too large.
   143  vec  (   4): Vectorized array expression.
   149  vec  (   4): Vectorized array expression.
   157  opt  (1593): Loop nest collapsed into one loop.
   157  vec  (   4): Vectorized array expression.
   184  vec  (   3): Unvectorized loop.
   184  vec  (  13): Overhead of loop division is too large.
   192  vec  (   4): Vectorized array expression.
   194  vec  (   4): Vectorized array expression.
   194  vec  (  26): Macro operation Sum/InnerProd.
   219  vec  (   3): Unvectorized loop.
   219  vec  (  13): Overhead of loop division is too large.
   225  vec  (   4): Vectorized array expression.
   249  vec  (   4): Vectorized array expression.
   251  vec  (   4): Vectorized array expression.
   258  vec  (   4): Vectorized array expression.
   260  vec  (   1): Vectorized loop.
   324  vec  (   4): Vectorized array expression.
   339  opt  (1082): Backward transfers inhibit loop optimization.
   339  vec  (   4): Vectorized array expression.
   389  opt  (1082): Backward transfers inhibit loop optimization.
   389  vec  (   4): Vectorized array expression.
   398  opt  (1082): Backward transfers inhibit loop optimization.
   398  vec  (   4): Vectorized array expression.
   415  opt  (1593): Loop nest collapsed into one loop.
   415  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:51 2008
FILE NAME: i.lpj_pftinout.f90
PROGRAM NAME: lpj_pftinout
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! throw out respectively introduce some PFTS
     2:            !
     3:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/lpj_pftinout.f90,v 1.7 2007/05/28 14:49:02 ssipsl Exp $
     4:            ! IPSL (2006)
     5:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     6:            !
     7:            MODULE lpj_pftinout
     8:            
     9:              ! modules used:
    10:            
    11:              USE ioipsl
    12:              USE stomate_constants
    13:            
    14:              IMPLICIT NONE
    15:            
    16:              ! private & public routines
    17:            
    18:              PRIVATE
    19:              PUBLIC pftinout,pftinout_clear
    20:            
    21:                ! first call
    22:                LOGICAL, SAVE                                             :: firstcall = .TRUE.
    23:            
    24:            CONTAINS
    25:            
    26:            
    27:              SUBROUTINE pftinout_clear
    28:                firstcall = .TRUE.
    29:              END SUBROUTINE pftinout_clear
    30:            
    31:              SUBROUTINE pftinout (npts, dt, adapted, regenerate, &
    32:                              neighbours, space_nat, veget, veget_max, &
    33:                              biomass, ind, age, leaf_frac, npp_longterm, lm_lastyearmax, senescence, &
    34:                              PFTpresent, everywhere, when_growthinit, need_adjacent, RIP_time, &
    35:                              co2_to_bm, &
    36:                              avail_tree, avail_grass)
    37:            
    38:                !
    39:                ! 0 declarations
    40:                !
    41:            
    42:                ! 0.1 input
    43:            
    44:                ! Domain size
    45:                INTEGER(i_std), INTENT(in)                                       :: npts
    46:                ! Time step (days)
    47:                REAL(r_std), INTENT(in)                                    :: dt
    48:                ! Winter not too cold
    49:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)              :: adapted
    50:                ! Winter sufficiently cold
    51:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)              :: regenerate
    52:                ! indices of the 8 neighbours of each grid point (1=N, 2=NE, 3=E, 4=SE, 5=S, 6=SW, 7=W, 8=NW)
    53:                INTEGER(i_std), DIMENSION(npts,8), INTENT(in)              :: neighbours
    54:                ! total natural space (fraction of total space)
    55:                REAL(r_std), DIMENSION(npts), INTENT(in)                   :: space_nat
    56:                ! fractional coverage on natural/agricultural ground, taking into
    57:                !   account LAI (=grid-scale fpc)
    58:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: veget
    59:                ! "maximal" coverage fraction of a PFT (LAI -> infinity) on nat/agri ground
    60:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: veget_max
    61:            
    62:                ! 0.2 modified fields
    63:            
    64:                ! biomass (gC/(m**2 of nat/agri ground))
    65:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)    :: biomass
    66:                ! density of individuals 1/m**2
    67:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: ind
    68:                ! mean age (years)
    69:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: age
    70:                ! fraction of leaves in leaf age class
    71:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout) :: leaf_frac
    72:                ! "long term" net primary productivity (gC/(m**2 of nat/agri ground)/year)
    73:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: npp_longterm
    74:                ! last year's maximum leaf mass, for each PFT (gC/(m**2 of nat/agri ground))
    75:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: lm_lastyearmax
    76:                ! is the plant senescent? (only for deciduous trees - carbohydrate reserve)
    77:                !         set to .FALSE. if PFT is introduced or killed
    78:                LOGICAL, DIMENSION(npts,npft), INTENT(inout)              :: senescence
    79:                ! PFT exists
    80:                LOGICAL, DIMENSION(npts,npft), INTENT(inout)              :: PFTpresent
    81:                ! is the PFT everywhere in the grid box or very localized (after its introduction)
    82:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: everywhere
    83:                ! how many days ago was the beginning of the growing season
    84:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: when_growthinit
    85:                ! in order for this PFT to be introduced, does it have to be present in an
    86:                !   adjacent grid box?
    87:                LOGICAL, DIMENSION(npts,npft), INTENT(inout)              :: need_adjacent
    88:                ! How much time ago was the PFT eliminated for the last time (y)
    89:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)           :: RIP_time
    90:                ! biomass uptaken (gC/(m**2 of total ground)/day)
    91:                REAL(r_std), DIMENSION(npts), INTENT(inout)                :: co2_to_bm
    92:            
    93:                ! 0.3 output
    94:            
    95:                ! space availability for trees on natural ground
    96:                REAL(r_std), DIMENSION(npts), INTENT(out)                  :: avail_tree
    97:                ! space availability for grasses on natural ground
    98:                REAL(r_std), DIMENSION(npts), INTENT(out)                  :: avail_grass
    99:            
   100:                ! 0.4 local
   101:            
   102:                ! minimum availability
   103:                REAL(r_std), PARAMETER                                     :: min_avail = 0.01
   104:                ! availability
   105:                REAL(r_std), DIMENSION(npts)                               :: avail
   106:                ! indices
   107:                INTEGER(i_std)                                             :: i,j
   108:                ! total woody vegetation cover or natural ground
   109:                REAL(r_std), DIMENSION(npts)                               :: sumfrac_wood
   110:                ! number of adjacent grid cells where PFT is ubiquitious
   111:                INTEGER(i_std), DIMENSION(npts)                            :: n_present
   112:                ! we can introduce this PFT
   113:                LOGICAL, DIMENSION(npts)                                  :: can_introduce
   114:            
   115:                ! =========================================================================
   116:            
   117:                IF (bavard.GE.3) WRITE(numout,*) 'Entering pftinout'
   118:            
   119:                !
   120:                ! 1 Messages
   121:                !
   122:            
   123:                IF ( firstcall ) THEN
   124:            
   125:                  WRITE(numout,*) 'pftinout: Minimum space availability: ', min_avail
   126:            
   127:                  firstcall = .FALSE.
   128:            
   129:                ENDIF
   130:            
   131:                !
   132:                ! 2 Space availability
   133:                !
   134:            
   135:                ! need to know total woody vegetation fraction
   136:            
   137: V======        sumfrac_wood(:) = 0.0
   138:            
   139: +------>       DO j = 1, npft
   140: |          
   141: |                IF ( tree(j) ) THEN
   142: |          
   143: |V=====            sumfrac_wood(:) = sumfrac_wood(:) + veget(:,j)
   144: |          
   145: |                ENDIF
   146: |          
   147: +------        ENDDO
   148:            
   149: V------>       avail_grass(:) = MAX( ( 1._r_std - sumfrac_wood(:) ), min_avail )
   150: |          
   151: V------        avail_tree(:) = MAX( ( fpc_crit - sumfrac_wood(:) ), min_avail )
   152:            
   153:                !
   154:                ! 3 Time since last elimination (y)
   155:                !
   156:            
   157: W*=====        RIP_time = RIP_time + dt / one_year
   158:            
   159:                !
   160:                ! 4 Agicultural PFTs: present if they are prescribed
   161:                !
   162:            
   163: +------>       DO j = 1, npft
   164: |          
   165: |                IF ( .NOT. natural(j) ) THEN
   166: |          
   167: |                  IF (bavard.GE.4) WRITE(numout,*) 'pftinout: Agricultural PFTs'
   168: |          
   169: |                  IF ( tree(j) ) THEN
   170: |          
   171: |                    !
   172: |                    ! 4.1 don't treat agricultural trees for the moment
   173: |                    !
   174: |          
   175: |                    WRITE(numout,*) 'pftinout: Agricultural trees not treated. We stop.'
   176: |                    STOP
   177: |          
   178: |                  ELSE
   179: |          
   180: |                    !
   181: |                    ! 4.2 grasses
   182: |                    !
   183: |          
   184: |+----->             DO i = 1, npts
   185: ||         
   186: ||                     IF ( ( veget_max(i,j) .GT. 0.0 ) .AND. ( .NOT. PFTpresent(i,j) ) ) THEN
   187: ||         
   188: ||                       ! prescribed, but not yet there.
   189: ||         
   190: ||                       ind(i,j) = veget_max(i,j)
   191: ||         
   192: ||V====                  biomass(i,j,:) = bm_sapl(j,:) * ind(i,j)
   193: ||         
   194: ||V====                  co2_to_bm(i) = co2_to_bm(i) + &
   195: ||                                      SUM( biomass(i,j,:) ) * ( 1. - space_nat(i) ) / dt
   196: ||         
   197: ||                       PFTpresent(i,j) = .TRUE.
   198: ||         
   199: ||                       everywhere(i,j) = 1.
   200: ||         
   201: ||                       senescence(i,j) = .FALSE.
   202: ||         
   203: ||                       age(i,j) = 0.
   204: ||         
   205: ||                     ENDIF  ! prescribed, but PFT not yet present
   206: ||         
   207: |+-----              ENDDO    ! loop over grid points
   208: |          
   209: |                  ENDIF
   210: |          
   211: |                ENDIF      ! not natural
   212: |          
   213: +------        ENDDO        ! loop over PFTs
   214:            
   215:                !
   216:                ! 5 Eliminate PFTs
   217:                !
   218:            
   219: +------>       DO j = 1, npft
   220: |          
   221: |                ! only for natural PFTs
   222: |          
   223: |                IF ( natural(j) ) THEN
   224: |          
   225: |V----->           WHERE (  PFTpresent(:,j) .AND. ( adapted(:,j) .LT. adapted_crit ) )
   226: ||         
   227: ||                   ! PFT there, but not adapted any more (ex: winter too cold): kill
   228: ||                   ! set number of individuals to zero - rest will be done in lpj_kill
   229: ||         
   230: |V-----              ind(:,j) = 0.0
   231: |          
   232: |                  ENDWHERE
   233: |          
   234: |                ENDIF    ! natural
   235: |          
   236: +------        ENDDO       ! loop over PFTs
   237:            
   238:                !
   239:                ! 6 Introduce PFTs
   240:                !
   241:            
   242: +------>       DO j = 1, npft
   243: |          
   244: |                IF ( natural(j) ) THEN
   245: |          
   246: |                  ! space availability for this PFT
   247: |          
   248: |                  IF ( tree(j) ) THEN
   249: |V=====              avail(:) = avail_tree(:)
   250: |                  ELSE
   251: |V=====              avail(:) = avail_grass(:)
   252: |                  ENDIF
   253: |          
   254: |                  !
   255: |                  ! 6.1 Check if PFT not present but (adapted and regenerative)
   256: |                  !
   257: |          
   258: |V=====            can_introduce(:) = .FALSE.
   259: |          
   260: |V----->           DO i = 1, npts
   261: ||         
   262: ||                   IF ( .NOT. PFTpresent(i,j) .AND. &
   263: ||                        ( adapted(i,j) .GT. adapted_crit ) .AND. &
   264: ||                        ( regenerate(i,j) .GT. regenerate_crit )  ) THEN
   265: ||         
   266: ||                     ! climate allows introduction
   267: ||         
   268: ||                     IF ( need_adjacent(i,j) ) THEN
   269: ||         
   270: ||                       ! 6.1.1 climate allows introduction, but we need to look at the neighbours
   271: ||                       !       If the PFT has totally invaded at least one adjacent
   272: ||                       !       grid cell, it can be introduced.
   273: ||           
   274: ||                       ! count number of totally invaded neighbours
   275: ||                       ! no loop so that it can vectorize
   276: ||           
   277: ||                       n_present(i) = 0
   278: ||           
   279: ||                       IF ( neighbours(i,1) .GT. 0 ) THEN
   280: ||                         IF ( everywhere(neighbours(i,1),j) .GE. 1.-min_stomate ) THEN
   281: ||                           n_present(i) = n_present(i)+1
   282: ||                         ENDIF
   283: ||                       ENDIF
   284: ||                       IF ( neighbours(i,3) .GT. 0 ) THEN
   285: ||                         IF ( everywhere(neighbours(i,3),j) .GE. 1.-min_stomate ) THEN
   286: ||                           n_present(i) = n_present(i)+1
   287: ||                         ENDIF
   288: ||                       ENDIF
   289: ||                       IF ( neighbours(i,5) .GT. 0 ) THEN
   290: ||                         IF ( everywhere(neighbours(i,5),j) .GE. 1.-min_stomate ) THEN
   291: ||                           n_present(i) = n_present(i)+1
   292: ||                         ENDIF
   293: ||                       ENDIF
   294: ||                       IF ( neighbours(i,7) .GT. 0 ) THEN
   295: ||                         IF ( everywhere(neighbours(i,7),j) .GE. 1.-min_stomate ) THEN
   296: ||                           n_present(i) = n_present(i)+1
   297: ||                         ENDIF
   298: ||                       ENDIF
   299: ||           
   300: ||                       IF ( n_present(i) .GT. 0 ) THEN
   301: ||           
   302: ||                         ! PFT is ubiquitious in at least one adjacent grid box
   303: ||                         can_introduce(i) = .TRUE.
   304: ||         
   305: ||                       ENDIF
   306: ||         
   307: ||                     ELSE
   308: ||         
   309: ||                       ! 6.1.2 we don't have to look at neighbours
   310: ||         
   311: ||                       can_introduce(i) = .TRUE.
   312: ||         
   313: ||                     ENDIF   ! do we have to look at the neighbours?
   314: ||         
   315: ||                   ENDIF     ! we'd like to introduce the PFT
   316: ||         
   317: |V-----            ENDDO       ! loop over grid points 
   318: |          
   319: |                  !
   320: |                  ! 6.2 additionally test whether the PFT has been eliminated lately, i.e.
   321: |                  !     less than 1.25 years ago. Do not take full years as success of
   322: |                  !     introduction might depend on season.
   323: |          
   324: |V----->           WHERE ( RIP_time(:,j) .LT. 1.25 )
   325: ||         
   326: ||                   ! PFT was eliminated lately - cannot reintroduce
   327: ||         
   328: |V-----              can_introduce(:) = .FALSE.
   329: |          
   330: |                  ENDWHERE
   331: |          
   332: |                  !
   333: |                  ! 6.3 Introduce that PFT where possible
   334: |                  !     "can_introduce" means that it either exists in neighbouring grid boxes 
   335: |                  !     or that we do not look at neighbours, that it has not been eliminated 
   336: |                  !     lately, and, of course, that the climate is good for that PFT.
   337: |                  !
   338: |          
   339: |V----->           WHERE ( can_introduce(:) )
   340: ||         
   341: ||                   PFTpresent(:,j) = .TRUE.
   342: ||         
   343: ||                   senescence(:,j) = .FALSE.
   344: ||         
   345: ||                   ! introduce at least a few saplings, even if canopy is closed
   346: ||         
   347: ||                   ind(:,j) = ind_0 * (dt/one_year) * avail(:)
   348: ||         
   349: ||         
   350: ||                   biomass(:,j,ileaf) = bm_sapl(j,ileaf) * ind(:,j)
   351: ||                   biomass(:,j,isapabove) = bm_sapl(j,isapabove) * ind(:,j)
   352: ||                   biomass(:,j,isapbelow) = bm_sapl(j,isapbelow) * ind(:,j)
   353: ||                   biomass(:,j,iheartabove) = bm_sapl(j,iheartabove) * ind(:,j)
   354: ||                   biomass(:,j,iheartbelow) = bm_sapl(j,iheartbelow) * ind(:,j)
   355: ||                   biomass(:,j,iroot) = bm_sapl(j,iroot) * ind(:,j)
   356: ||                   biomass(:,j,ifruit) = bm_sapl(j,ifruit) * ind(:,j)
   357: ||                   biomass(:,j,icarbres) = bm_sapl(j,icarbres) * ind(:,j)
   358: ||         
   359: ||                   co2_to_bm(:) = &
   360: ||                     co2_to_bm(:) + space_nat(:) / dt * &
   361: ||                                    ( biomass(:,j,ileaf) + biomass(:,j,isapabove) + &
   362: ||                                      biomass(:,j,isapbelow) + biomass(:,j,iheartabove) + &
   363: ||                                      biomass(:,j,iheartbelow) + biomass(:,j,iroot) + &
   364: ||                                      biomass(:,j,ifruit) + biomass(:,j,icarbres) )
   365: ||         
   366: ||                   when_growthinit(:,j) = large_value
   367: ||         
   368: ||                   age(:,j) = 0.0
   369: ||         
   370: ||                   ! all leaves are young
   371: ||                   leaf_frac(:,j,1) = 1.0
   372: ||         
   373: ||                   ! non-zero "long term" npp and last year's leaf mass for saplings -
   374: ||                   !   so they won't be killed off by gap or kill
   375: ||         
   376: ||                   npp_longterm(:,j) = 10.
   377: ||         
   378: |V-----              lm_lastyearmax(:,j) = bm_sapl(j,ileaf) * ind(:,j)
   379: |          
   380: |                  ENDWHERE    ! we can introduce the PFT
   381: |          
   382: |                  !
   383: |                  ! 6.4 expansion of the PFT within the grid box (not to be confused with areal
   384: |                  !     coverage)
   385: |                  !
   386: |          
   387: |                  IF ( treat_expansion ) THEN
   388: |          
   389: |V----->             WHERE ( can_introduce(:) )
   390: ||                     ! low value at the beginning
   391: |V-----                everywhere(:,j) = 0.05
   392: |                    ENDWHERE
   393: |          
   394: |                  ELSE
   395: |          
   396: |                    ! expansion is not treated
   397: |          
   398: |V----->             WHERE ( can_introduce(:) )
   399: |V-----                everywhere(:,j) = 1.
   400: |                    ENDWHERE
   401: |          
   402: |                  ENDIF   ! treat expansion
   403: |          
   404: |                ENDIF     ! only natural PFTs
   405: |          
   406: +------        ENDDO       ! loop over PFTs
   407:            
   408:                !
   409:                ! 7 If a PFT has been present once in a grid box, we suppose that it will survive
   410:                !   in isolated places (e.g., an oasis) within that grid box, even if it gets
   411:                !   officially eliminated from it later. That means that if climate becomes favorable
   412:                !   again, it will not need to get seeds from adjacent grid cells.
   413:                !
   414:            
   415: *W----->       WHERE ( PFTpresent )
   416: *W-----          need_adjacent = .FALSE.
   417:                ENDWHERE
   418:            
   419:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving pftinout'
   420:            
   421:              END SUBROUTINE pftinout
   422:            
   423:            END MODULE lpj_pftinout
