Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:54 2008
FILE NAME: i.stomate_data.f90
PROGRAM NAME: stomate_data
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

    56  vec  (   3): Unvectorized loop.
   272  vec  (   6): Unvectorized array expression.
   272  vec  (   7): Iteration count is too small.
   281  vec  (   6): Unvectorized array expression.
   281  vec  (   7): Iteration count is too small.
   340  vec  (   6): Unvectorized array expression.
   340  vec  (   7): Iteration count is too small.
   350  vec  (   6): Unvectorized array expression.
   350  vec  (   7): Iteration count is too small.
   647  vec  (   3): Unvectorized loop.
   647  vec  (  13): Overhead of loop division is too large.
   649  vec  (  22): Dependency unknown. Unvectorizable dependency is assumed.:npft_stomate
   649  vec  (   4): Vectorized array expression.
   651  opt  (1017): Subroutine call prevents optimization.
   651  vec  (  17): Unvectorizable statement.
   655  vec  (  22): Dependency unknown. Unvectorizable dependency is assumed.:j
   659  warn (  83): Dummy argument "lalo" is not used.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:54 2008
FILE NAME: i.stomate_data.f90
PROGRAM NAME: stomate_data
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! defines PFT parameters
     2:            ! the geographical coordinates might be used for defining some additional parameters
     3:            ! (e.g. frequency of anthropogenic fires, irrigation of agricultural surfaces, etc.)
     4:            !
     5:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_data.f90,v 1.10 2007/05/28 14:51:50 ssipsl Exp $
     6:            ! IPSL (2006)
     7:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     8:            !
     9:            MODULE stomate_data
    10:            
    11:              ! modules used:
    12:            
    13:              USE constantes_veg
    14:              USE constantes_co2
    15:              USE stomate_constants
    16:            
    17:              IMPLICIT NONE
    18:            
    19:              ! private & public routines
    20:            
    21:              PRIVATE
    22:              PUBLIC data
    23:            
    24:            CONTAINS
    25:            
    26:              SUBROUTINE data (npts, lalo)
    27:            
    28:                !
    29:                ! 0 declarations
    30:                !
    31:            
    32:                ! 0.1 input
    33:            
    34:                ! Domain size
    35:                INTEGER(i_std), INTENT(in)                               :: npts
    36:                ! Geographical coordinates (latitude,longitude)
    37:                REAL(r_std),DIMENSION (npts,2), INTENT (in)        :: lalo
    38:            
    39:                ! 0.2 local variables
    40:            
    41:                ! Index
    42:                INTEGER(i_std)                                    :: j
    43:                ! alpha's : ?
    44:                REAL(r_std)                                        :: alpha
    45:                ! stem diameter
    46:                REAL(r_std)                                        :: dia
    47:                ! Sapling CSA
    48:                REAL(r_std)                                        :: csa_sap
    49:                ! mass ratio (heartwood+sapwood)/sapwood
    50:                REAL(r_std), PARAMETER                             :: x = 3.
    51:            
    52:                ! =========================================================================
    53:            
    54:                IF ( bavard .GE. 1 ) WRITE(numout,*) 'data: PFT characteristics'
    55:            
    56: +------>       DO j = 1, npft
    57: |          
    58: |                IF ( bavard .GE. 1 ) WRITE(numout,'(a,i3,a,a)') '    > PFT#',j,': ', PFT_name(j)
    59: |          
    60: |                !
    61: |                ! 1 tree?
    62: |                !
    63: |          
    64: |                IF ( leaf_tab(j) .LE. 2 ) THEN
    65: |                  tree(j) = .TRUE.
    66: |                ELSE
    67: |                  tree(j) = .FALSE.
    68: |                ENDIF
    69: |          
    70: |                IF ( bavard .GE. 1 ) WRITE(numout,*) '       tree: ', tree(j)
    71: |          
    72: |                !
    73: |                ! 2 flamability
    74: |                !
    75: |          
    76: |                IF ( bavard .GE. 1 ) WRITE(numout,*) '       litter flamability:', flam(j)
    77: |          
    78: |                !
    79: |                ! 3 fire resistance
    80: |                !
    81: |          
    82: |                IF ( bavard .GE. 1 ) WRITE(numout,*) '       fire resistance:', resist(j)
    83: |          
    84: |                !
    85: |                ! 4 specific leaf area per mass carbon = 2 * sla / dry mass
    86: |                !
    87: |          
    88: |          !!$      IF ( leaf_tab(j) .EQ. 1 ) THEN
    89: |          !!$
    90: |          !!$        ! broad leaved tree
    91: |          !!$
    92: |          !!$        sla(j) = 2. * ( 10. ** ( 2.41 - 0.38 * LOG10(12./leaflife_tab(j)) ) ) *1e-4
    93: |          !!$
    94: |          !!$      ELSE
    95: |          !!$
    96: |          !!$        ! needle leaved or grass (Reich et al 1992)
    97: |          !!$
    98: |          !!$        sla(j) = 2. * ( 10. ** ( 2.29 - 0.4 * LOG10(12./leaflife_tab(j)) ) ) *1e-4
    99: |          !!$
   100: |          !!$      ENDIF
   101: |          !!$
   102: |          !!$      IF ( ( leaf_tab(j) .EQ. 2 ) .AND. ( pheno_type_tab(j) .EQ. 2 ) ) THEN
   103: |          !!$
   104: |          !!$        ! summergreen needle leaf
   105: |          !!$
   106: |          !!$        sla(j) = 1.25 * sla(j)
   107: |          !!$
   108: |          !!$      ENDIF
   109: |                IF ( leaf_tab(j) .EQ. 2 ) THEN
   110: |          
   111: |                   ! needle leaved tree
   112: |                   sla(j) = 2. * ( 10. ** ( 2.29 - 0.4 * LOG10(12./leaflife_tab(j)) ) ) *1e-4
   113: |                   
   114: |                ELSE
   115: |                   
   116: |                   ! broad leaved tree or grass (Reich et al 1992)
   117: |                   sla(j) = 2. * ( 10. ** ( 2.41 - 0.38 * LOG10(12./leaflife_tab(j)) ) ) *1e-4
   118: |                   
   119: |                ENDIF
   120: |          
   121: |                IF ( bavard .GE. 1 ) WRITE(numout,*) '       specific leaf area (m**2/gC):', sla(j)
   122: |          
   123: |                !
   124: |                ! 5 sapling characteristics
   125: |                !
   126: |          
   127: |                IF ( tree(j) ) THEN
   128: |          
   129: |                  ! 5.1 trees
   130: |          
   131: |                  alpha = alpha_tree
   132: |          
   133: |                  bm_sapl(j,ileaf) = &
   134: |                    ( (4.*pipe_tune1 * ( x*4.*sla(j)/(pi*pipe_k1))**.8 ) / sla(j) ) ** 5.
   135: |          
   136: |                  IF ( pheno_type_tab(j) .NE. 1 ) THEN
   137: |                    ! not evergreen
   138: |                    bm_sapl(j,icarbres) = 5. * bm_sapl(j,ileaf)
   139: |                  ELSE
   140: |                    bm_sapl(j,icarbres) = 0.0
   141: |                  ENDIF
   142: |          
   143: |                  csa_sap = bm_sapl(j,ileaf) / ( pipe_k1 / sla(j) )
   144: |          
   145: |                  dia = ( x * csa_sap * 4. / pi ) ** 0.5
   146: |          
   147: |                  bm_sapl(j,isapabove) = &
   148: |                    .5 * pipe_density * csa_sap * pipe_tune2 * dia ** pipe_tune3
   149: |                  bm_sapl(j,isapbelow) = bm_sapl(j,isapabove)
   150: |          
   151: |                  bm_sapl(j,iheartabove) = 2. * bm_sapl(j,isapabove)
   152: |                  bm_sapl(j,iheartbelow) = 2. * bm_sapl(j,isapbelow)
   153: |          
   154: |                ELSE
   155: |          
   156: |                  ! 5.2 grasses
   157: |          
   158: |                  alpha = alpha_grass
   159: |          
   160: |                  IF ( natural(j) ) THEN
   161: |                    bm_sapl(j,ileaf) = 0.1 / sla(j)
   162: |                  ELSE
   163: |                    bm_sapl(j,ileaf) = 1.0 / sla(j)
   164: |                  ENDIF
   165: |          
   166: |                  bm_sapl(j,icarbres) = 5.*bm_sapl(j,ileaf)
   167: |          
   168: |                  bm_sapl(j,isapabove) = 0.
   169: |                  bm_sapl(j,isapbelow) = 0.
   170: |          
   171: |                  bm_sapl(j,iheartabove) = 0.
   172: |                  bm_sapl(j,iheartbelow) = 0.
   173: |          
   174: |                ENDIF
   175: |          
   176: |                bm_sapl(j,iroot) = 0.1 * (1./alpha) * bm_sapl(j,ileaf)
   177: |          
   178: |                bm_sapl(j,ifruit) = 0.3 * bm_sapl(j,ileaf)
   179: |          
   180: |                IF ( bavard .GE. 1 ) THEN
   181: |                  WRITE(numout,*) '       sapling biomass (gC):'
   182: |                  WRITE(numout,*) '         leaves:',bm_sapl(j,ileaf)
   183: |                  WRITE(numout,*) '         sap above ground:',bm_sapl(j,isapabove)
   184: |                  WRITE(numout,*) '         sap below ground:',bm_sapl(j,isapbelow)
   185: |                  WRITE(numout,*) '         heartwood above ground:',bm_sapl(j,iheartabove)
   186: |                  WRITE(numout,*) '         heartwood below ground:',bm_sapl(j,iheartbelow)
   187: |                  WRITE(numout,*) '         roots:',bm_sapl(j,iroot)
   188: |                  WRITE(numout,*) '         fruits:',bm_sapl(j,ifruit)
   189: |                  WRITE(numout,*) '         carbohydrate reserve:',bm_sapl(j,icarbres)
   190: |                ENDIF
   191: |          
   192: |                !
   193: |                ! 6 migration speed (m/year)
   194: |                !
   195: |          
   196: |                IF ( tree(j) ) THEN
   197: |          
   198: |                  migrate(j) = 10.*1.E3
   199: |          
   200: |                ELSE
   201: |          
   202: |                  ! can be any value as grasses are, per definitionem, everywhere (big leaf).
   203: |                  migrate(j) = 10.*1.E3
   204: |          
   205: |                ENDIF
   206: |          
   207: |                IF ( bavard .GE. 1 ) WRITE(numout,*) '       migration speed (m/year):', migrate(j)
   208: |          
   209: |                !
   210: |                ! 7 critical stem diameter: beyond this diameter, the crown area no longer
   211: |                !     increases
   212: |                !
   213: |          
   214: |                IF ( tree(j) ) THEN
   215: |          
   216: |                  maxdia(j) = ( ( pipe_tune4 / ((pipe_tune2*pipe_tune3)/(100.**pipe_tune3)) ) &
   217: |                                 ** ( 1. / ( pipe_tune3 - 1. ) ) ) * 0.01
   218: |          
   219: |                ELSE
   220: |          
   221: |                  maxdia(j) = undef
   222: |          
   223: |                ENDIF
   224: |          
   225: |                IF ( bavard .GE. 1 ) WRITE(numout,*) '       critical stem diameter (m):', maxdia(j)
   226: |          
   227: |                !
   228: |                ! 8 Coldest tolerable temperature
   229: |                !
   230: |          
   231: |                IF ( ABS( tmin_crit_tab(j) - undef ) .GT. min_stomate ) THEN
   232: |                  tmin_crit(j) = tmin_crit_tab(j) + ZeroCelsius
   233: |                ELSE
   234: |                  tmin_crit(j) = undef
   235: |                ENDIF
   236: |          
   237: |                IF ( bavard .GE. 1 ) &
   238: |                  WRITE(numout,*) '       coldest tolerable temperature (K):', tmin_crit(j)
   239: |          
   240: |                !
   241: |                ! 9 Maximum temperature of the coldest month: need to be below this temperature
   242: |                !      for a certain time to regrow leaves next spring
   243: |                !
   244: |          
   245: |                IF ( ABS ( tcm_crit_tab(j) - undef ) .GT. min_stomate ) THEN
   246: |                  tcm_crit(j) = tcm_crit_tab(j) + ZeroCelsius
   247: |                ELSE
   248: |                  tcm_crit(j) = undef
   249: |                ENDIF
   250: |          
   251: |                IF ( bavard .GE. 1 ) &
   252: |                  WRITE(numout,*) '       vernalization temperature (K):', tcm_crit(j)
   253: |          
   254: |                !
   255: |                ! 10 critical values for phenology
   256: |                !
   257: |          
   258: |                ! 10.1 model used
   259: |          
   260: |                pheno_crit%pheno_model(j) = pheno_model_tab(j)
   261: |          
   262: |                IF ( bavard .GE. 1 ) &
   263: |                  WRITE(numout,*) '       phenology model used: ',pheno_crit%pheno_model(j)
   264: |          
   265: |                ! 10.2 growing degree days. What kind of gdd is meant (i.e. threshold 0 or -5 deg C
   266: |                !        or whatever), depends on how this is used in stomate_phenology.
   267: |          
   268: |                pheno_crit%gdd(j,1) = gdd_crit1_tab(j)
   269: |                pheno_crit%gdd(j,2) = gdd_crit2_tab(j)
   270: |                pheno_crit%gdd(j,3) = gdd_crit3_tab(j)
   271: |          
   272: |*=====          IF ( ( bavard .GE. 1 ) .AND. ( ALL(pheno_crit%gdd(j,:) .NE. undef) ) ) THEN
   273: |                  WRITE(numout,*) '         critical GDD is a function of long term T (C):'
   274: |                  WRITE(numout,*) '          ',pheno_crit%gdd(j,1), &
   275: |                                             ' + T *',pheno_crit%gdd(j,2), &
   276: |                                             ' + T^2 *',pheno_crit%gdd(j,3)
   277: |                ENDIF
   278: |          
   279: |                ! consistency check
   280: |          
   281: |*=====          IF ( ( ( pheno_crit%pheno_model(j) .EQ. 'moigdd' ) .OR. &
   282: |                       ( pheno_crit%pheno_model(j) .EQ. 'humgdd' )       ) .AND. &
   283: |                     ( ANY(pheno_crit%gdd(j,:) .EQ. undef) )                      ) THEN
   284: |                  STOP 'problem with phenology parameters, critical GDD.'
   285: |                ENDIF
   286: |          
   287: |                ! 10.3 number of growing days
   288: |          
   289: |                pheno_crit%ngd(j) = ngd_crit_tab(j)
   290: |          
   291: |                IF ( ( bavard .GE. 1 ) .AND. ( pheno_crit%ngd(j) .NE. undef ) ) &
   292: |                  WRITE(numout,*) '         critical NGD:', pheno_crit%ngd(j)
   293: |          
   294: |                ! 10.4 critical temperature for ncd vs. gdd function in phenology
   295: |          
   296: |                pheno_crit%ncdgdd_temp(j) = ncdgdd_temp_tab(j)
   297: |          
   298: |                IF ( ( bavard .GE. 1 ) .AND. ( pheno_crit%ncdgdd_temp(j) .NE. undef ) ) &
   299: |                  WRITE(numout,*) '         critical temperature for NCD vs. GDD (C):', &
   300: |                                  pheno_crit%ncdgdd_temp(j)
   301: |          
   302: |                ! 10.5 humidity fractions
   303: |          
   304: |                pheno_crit%hum_frac(j) = hum_frac_tab(j)
   305: |          
   306: |                IF ( ( bavard .GE. 1 ) .AND. ( pheno_crit%hum_frac(j) .NE. undef ) ) &
   307: |                  WRITE(numout,*) '         critical humidity fraction:', pheno_crit%hum_frac(j)
   308: |          
   309: |                ! 10.6 minimum time during which there was no photosynthesis
   310: |          
   311: |                pheno_crit%lowgpp_time(j) = lowgpp_time_tab(j)
   312: |          
   313: |                IF ( ( bavard .GE. 1 ) .AND. ( pheno_crit%lowgpp_time(j) .NE. undef ) ) &
   314: |                  WRITE(numout,*) '         minimum dormance duration (d):', pheno_crit%lowgpp_time(j)
   315: |          
   316: |                ! 10.7 minimum time elapsed since moisture minimum (d)
   317: |          
   318: |                pheno_crit%hum_min_time(j) = hum_min_time_tab(j)
   319: |          
   320: |                IF ( ( bavard .GE. 1 ) .AND. ( pheno_crit%hum_min_time(j) .NE. undef ) ) &
   321: |                  WRITE(numout,*) '         time to wait after moisture min (d):', pheno_crit%hum_min_time(j)
   322: |          
   323: |                !
   324: |                ! 11 critical values for senescence
   325: |                !
   326: |          
   327: |                ! 11.1 type of senescence
   328: |          
   329: |                pheno_crit%senescence_type(j) = senescence_type_tab(j)
   330: |          
   331: |                IF ( bavard .GE. 1 ) &
   332: |                  WRITE(numout,*) '       type of senescence: ',pheno_crit%senescence_type(j)
   333: |          
   334: |                ! 11.2 critical temperature for senescence
   335: |          
   336: |                pheno_crit%senescence_temp(j,1) = senescence_temp1_tab(j)
   337: |                pheno_crit%senescence_temp(j,2) = senescence_temp2_tab(j)
   338: |                pheno_crit%senescence_temp(j,3) = senescence_temp3_tab(j)
   339: |          
   340: |*=====          IF ( ( bavard .GE. 1 ) .AND. ( ALL(pheno_crit%senescence_temp(j,:) .NE. undef) ) ) THEN
   341: |                  WRITE(numout,*) '         critical temperature for senescence (C) is'
   342: |                  WRITE(numout,*) '          a function of long term T (C):'
   343: |                  WRITE(numout,*) '          ',pheno_crit%senescence_temp(j,1), &
   344: |                                             ' + T *',pheno_crit%senescence_temp(j,2), &
   345: |                                             ' + T^2 *',pheno_crit%senescence_temp(j,3)
   346: |                ENDIF
   347: |          
   348: |                ! consistency check
   349: |          
   350: |*=====          IF ( ( ( pheno_crit%senescence_type(j) .EQ. 'cold' ) .OR. &
   351: |                       ( pheno_crit%senescence_type(j) .EQ. 'mixed' )      ) .AND. &
   352: |                     ( ANY(pheno_crit%senescence_temp(j,:) .EQ. undef ) )           ) THEN
   353: |                  STOP 'problem with senescence parameters, temperature.'
   354: |                ENDIF
   355: |          
   356: |                ! 11.3 critical relative moisture availability for senescence
   357: |          
   358: |                pheno_crit%senescence_hum(j) = senescence_hum_tab(j)
   359: |          
   360: |                IF ( ( bavard .GE. 1 ) .AND. ( pheno_crit%senescence_hum(j) .NE. undef ) ) &
   361: |                  WRITE(numout,*) '         max. critical relative moisture availability for senescence:', &
   362: |                                  pheno_crit%senescence_hum(j)
   363: |          
   364: |                ! consistency check
   365: |          
   366: |                IF ( ( ( pheno_crit%senescence_type(j) .EQ. 'dry' ) .OR. &
   367: |                       ( pheno_crit%senescence_type(j) .EQ. 'mixed' )     ) .AND. &
   368: |                     ( pheno_crit%senescence_hum(j) .EQ. undef )                   ) THEN
   369: |                  STOP 'problem with senescence parameters, humidity.'
   370: |                ENDIF
   371: |          
   372: |                ! 14.3 relative moisture availability above which there is no moisture-related
   373: |                !      senescence
   374: |           
   375: |                pheno_crit%nosenescence_hum(j) = nosenescence_hum_tab(j)
   376: |           
   377: |                IF ( ( bavard .GE. 1 ) .AND. ( pheno_crit%nosenescence_hum(j) .NE. undef ) ) &
   378: |                  WRITE(numout,*) '         relative moisture availability above which there is'
   379: |                  WRITE(numout,*) '             no moisture-related senescence:', &
   380: |                                  pheno_crit%nosenescence_hum(j)
   381: |          
   382: |                  pheno_crit% max_turnover_time(j) = max_turnover_time_tab(j)
   383: |                  pheno_crit% min_turnover_time(j) = min_turnover_time_tab(j)
   384: |                  pheno_crit% min_leaf_age_for_senescence(j) = min_leaf_age_for_senescence_tab(j)
   385: |          
   386: |                ! consistency check
   387: |           
   388: |                IF ( ( ( pheno_crit%senescence_type(j) .EQ. 'dry' ) .OR. &
   389: |                       ( pheno_crit%senescence_type(j) .EQ. 'mixed' )     ) .AND. &
   390: |                     ( pheno_crit%nosenescence_hum(j) .EQ. undef )                   ) THEN
   391: |                  STOP 'problem with senescence parameters, humidity.'
   392: |                ENDIF
   393: |          
   394: |                !
   395: |                ! 12 sapwood -> heartwood conversion time
   396: |                !
   397: |          
   398: |                IF ( bavard .GE. 1 ) &
   399: |                  WRITE(numout,*) '       sapwood -> heartwood conversion time (d):', tau_sap(j)
   400: |          
   401: |                !
   402: |                ! 13 fruit lifetime
   403: |                !
   404: |          
   405: |                IF ( bavard .GE. 1 ) WRITE(numout,*) '       fruit lifetime (d):', tau_fruit(j)
   406: |          
   407: |                !
   408: |                ! 14 length of leaf death
   409: |                !      For evergreen trees, this variable determines the lifetime of the leaves.
   410: |                !      Note that it is different from the value given in leaflife_tab.
   411: |                !
   412: |          
   413: |                pheno_crit%leaffall(j) = leaffall_tab(j)
   414: |          
   415: |                IF ( bavard .GE. 1 ) &
   416: |                  WRITE(numout,*) '       length of leaf death (d):', pheno_crit%leaffall(j)
   417: |          
   418: |                !
   419: |                ! 15 maximum lifetime of leaves
   420: |                !
   421: |          
   422: |                pheno_crit%leafagecrit(j) = leafagecrit_tab(j)
   423: |          
   424: |                IF ( ( bavard .GE. 1 ) .AND. ( pheno_crit%leafagecrit(j) .NE. undef ) ) &
   425: |                  WRITE(numout,*) '       critical leaf age (d):', pheno_crit%leafagecrit(j)
   426: |          
   427: |                !
   428: |                ! 16 time constant for leaf age discretisation (d)
   429: |                !
   430: |          
   431: |                leaf_timecst(j) = pheno_crit%leafagecrit(j) / REAL( nleafages,r_std )
   432: |          
   433: |                IF ( bavard .GE. 1 ) &
   434: |                  WRITE(numout,*) '       time constant for leaf age discretisation (d):', &
   435: |                                  leaf_timecst(j)
   436: |          
   437: |                !
   438: |                ! 17 minimum lai, initial
   439: |                !
   440: |          
   441: |                IF ( tree(j) ) THEN
   442: |                  pheno_crit%lai_initmin(j) = 0.3
   443: |                ELSE
   444: |                  pheno_crit%lai_initmin(j) = 0.1
   445: |                ENDIF
   446: |          
   447: |                IF ( bavard .GE. 1 ) &
   448: |                  WRITE(numout,*) '       initial LAI:', pheno_crit%lai_initmin(j)
   449: |          
   450: |                !
   451: |                ! 19 maximum LAI
   452: |                !
   453: |          
   454: |                IF ( bavard .GE. 1 ) &
   455: |                  WRITE(numout,*) '       critical LAI above which no leaf allocation:', lai_max(j)
   456: |          
   457: |                !
   458: |                ! 20 fraction of primary leaf and root allocation put into reserve
   459: |                !
   460: |          
   461: |                IF ( bavard .GE. 1 ) &
   462: |                  WRITE(numout,*) '       reserve allocation factor:', ecureuil(j)
   463: |          
   464: |                !
   465: |                ! 21 maintenance respiration coefficient (g/g/day) at 0 deg C
   466: |                !
   467: |          
   468: |                coeff_maint_zero(j,ileaf) = cm_zero_leaf_tab(j)
   469: |                coeff_maint_zero(j,isapabove) = cm_zero_sapabove_tab(j)
   470: |                coeff_maint_zero(j,isapbelow) = cm_zero_sapbelow_tab(j)
   471: |                coeff_maint_zero(j,iheartabove) = cm_zero_heartabove_tab(j)
   472: |                coeff_maint_zero(j,iheartbelow) = cm_zero_heartbelow_tab(j)
   473: |                coeff_maint_zero(j,iroot) = cm_zero_root_tab(j)
   474: |                coeff_maint_zero(j,ifruit) = cm_zero_fruit_tab(j)
   475: |                coeff_maint_zero(j,icarbres) = cm_zero_carbres_tab(j)
   476: |          
   477: |                IF ( bavard .GE. 1 ) THEN
   478: |          
   479: |                  WRITE(numout,*) '       maintenance respiration coefficient (g/g/day) at 0 deg C:'
   480: |                  WRITE(numout,*) '         . leaves: ',coeff_maint_zero(j,ileaf)
   481: |                  WRITE(numout,*) '         . sapwood above ground: ',coeff_maint_zero(j,isapabove)
   482: |                  WRITE(numout,*) '         . sapwood below ground: ',coeff_maint_zero(j,isapbelow)
   483: |                  WRITE(numout,*) '         . heartwood above ground: ',coeff_maint_zero(j,iheartabove)
   484: |                  WRITE(numout,*) '         . heartwood below ground: ',coeff_maint_zero(j,iheartbelow)
   485: |                  WRITE(numout,*) '         . roots: ',coeff_maint_zero(j,iroot)
   486: |                  WRITE(numout,*) '         . fruits: ',coeff_maint_zero(j,ifruit)
   487: |                  WRITE(numout,*) '         . carbohydrate reserve: ',coeff_maint_zero(j,icarbres)
   488: |          
   489: |                ENDIF
   490: |          
   491: |                !
   492: |                ! 22 parameter for temperature sensitivity of maintenance respiration
   493: |                !
   494: |          
   495: |                maint_resp_slope(j,1) = maint_resp_slope1_tab(j)
   496: |                maint_resp_slope(j,2) = maint_resp_slope2_tab(j)
   497: |                maint_resp_slope(j,3) = maint_resp_slope3_tab(j)
   498: |          
   499: |                IF ( bavard .GE. 1 ) &
   500: |                  WRITE(numout,*) '       temperature sensitivity of maintenance respiration (1/K) is'
   501: |                  WRITE(numout,*) '          a function of long term T (C):'
   502: |                  WRITE(numout,*) '          ',maint_resp_slope(j,1),' + T *',maint_resp_slope(j,2), &
   503: |                                             ' + T^2 *',maint_resp_slope(j,3)
   504: |          
   505: |                !
   506: |                ! 23 natural ?
   507: |                !
   508: |          
   509: |                IF ( bavard .GE. 1 ) &
   510: |                  WRITE(numout,*) '       Natural:', natural(j)
   511: |          
   512: |                !
   513: |                ! 24 Vcmax et Vjmax
   514: |                !
   515: |          
   516: |                IF ( bavard .GE. 1 ) &
   517: |                  WRITE(numout,*) '       Maximum rate of carboxylation:', vcmax_opt(j)
   518: |          
   519: |                IF ( bavard .GE. 1 ) &
   520: |                  WRITE(numout,*) '       Maximum rate of RUbp regeneration:', vjmax_opt(j)
   521: |          
   522: |                !
   523: |                ! 25 constants for photosynthesis temperatures
   524: |                !
   525: |          
   526: |                t_photo%t_min_a(j) = tphoto_min_a_tab(j)
   527: |                t_photo%t_min_b(j) = tphoto_min_b_tab(j)
   528: |                t_photo%t_min_c(j) = tphoto_min_c_tab(j)
   529: |                t_photo%t_opt_a(j) = tphoto_opt_a_tab(j)
   530: |                t_photo%t_opt_b(j) = tphoto_opt_b_tab(j)
   531: |                t_photo%t_opt_c(j) = tphoto_opt_c_tab(j)
   532: |                t_photo%t_max_a(j) = tphoto_max_a_tab(j)
   533: |                t_photo%t_max_b(j) = tphoto_max_b_tab(j)
   534: |                t_photo%t_max_c(j) = tphoto_max_c_tab(j)
   535: |          
   536: |                IF ( bavard .GE. 1 ) THEN
   537: |                   WRITE(numout,*) '       min. temperature for photosynthesis as a function of long term T (C):'
   538: |                   WRITE(numout,*) '          ',t_photo%t_min_c(j), &
   539: |                        ' + T*',t_photo%t_min_b(j), &
   540: |                        ' + T^2*',t_photo%t_min_a(j)
   541: |                   WRITE(numout,*) '       opt. temperature for photosynthesis as a function of long term T (C):'
   542: |                   WRITE(numout,*) '          ',t_photo%t_opt_c(j), &
   543: |                        ' + T*',t_photo%t_opt_b(j), &
   544: |                        ' + T^2*',t_photo%t_opt_a(j)
   545: |                   WRITE(numout,*) '       max. temperature for photosynthesis as a function of long term T (C):'
   546: |                   WRITE(numout,*) '          ',t_photo%t_max_c(j), &
   547: |                        ' + T*',t_photo%t_max_b(j), &
   548: |                        ' + T^2*',t_photo%t_max_a(j)
   549: |                ENDIF
   550: |          
   551: |                !
   552: |                ! 26 corresponding PFT number in Sechiba
   553: |                !
   554: |          
   555: |                IF ( bavard .GE. 1 ) THEN
   556: |          
   557: |                  WRITE(numout,*) '       corresponding PFT number in Sechiba:', ipft_sechiba(j)
   558: |          
   559: |                  WRITE(numout,*) '       Slope of the gs/A relation:', &
   560: |                                             gsslope(ipft_sechiba(j))
   561: |                  WRITE(numout,*) '       Intercept of the gs/A relation:', &
   562: |                                             gsoffset(ipft_sechiba(j))
   563: |                  WRITE(numout,*) '       C4 photosynthesis:', is_c4(ipft_sechiba(j))
   564: |                  WRITE(numout,*) '       Depth constant for root profile (m):', &
   565: |                                             1./humcste(ipft_sechiba(j))
   566: |          
   567: |                ENDIF
   568: |          
   569: |                !
   570: |                ! 27 extinction coefficient of the Monsi&Seaki (53) relationship
   571: |                !
   572: |          
   573: |                ext_coeff(j) = ext_coef(ipft_sechiba(j))
   574: |          
   575: |                IF ( bavard .GE. 1 ) THEN
   576: |                  WRITE(numout,*) '       extinction coefficient:', ext_coeff(j)
   577: |                ENDIF
   578: |          
   579: |                !
   580: |                ! 28 check coherence between tree definitions
   581: |                !      this is not absolutely necessary (just security)
   582: |                !
   583: |          
   584: |                IF ( tree(j) .NEQV. is_tree(ipft_sechiba(j)) ) THEN
   585: |                  STOP 'Definition of tree/not tree not coherent'
   586: |                ENDIF
   587: |          
   588: +------        ENDDO
   589:            
   590:                !
   591:                ! 29 time scales for phenology and other processes (in days)
   592:                !
   593:            
   594:                pheno_crit%tau_hum_month = 20.            ! (!)
   595:            
   596:                pheno_crit%tau_hum_week = 7.
   597:            
   598:                pheno_crit%tau_t2m_month = 20.            ! (!)
   599:            
   600:                pheno_crit%tau_t2m_week = 7.
   601:            
   602:                pheno_crit%tau_tsoil_month = 20.          ! (!)
   603:            
   604:                pheno_crit%tau_soilhum_month = 20.        ! (!)
   605:            
   606:                pheno_crit%tau_gpp_week = 7.
   607:            
   608:                pheno_crit%tau_gdd = 40.
   609:            
   610:                pheno_crit%tau_ngd = 50.
   611:            
   612:                pheno_crit%tau_longterm = 3. * one_year
   613:            
   614:                IF ( bavard .GE. 1 ) THEN
   615:            
   616:                  WRITE(numout,*) '   > time scale for ''monthly'' moisture availability (d):', &
   617:                                  pheno_crit%tau_hum_month
   618:                  WRITE(numout,*) '   > time scale for ''weekly'' moisture availability (d):', &
   619:                                  pheno_crit%tau_hum_week
   620:                  WRITE(numout,*) '   > time scale for ''monthly'' 2 meter temperature (d):', &
   621:                                  pheno_crit%tau_t2m_month
   622:                  WRITE(numout,*) '   > time scale for ''weekly'' 2 meter temperature (d):', &
   623:                                  pheno_crit%tau_t2m_week
   624:                  WRITE(numout,*) '   > time scale for ''weekly'' GPP (d):', &
   625:                                  pheno_crit%tau_gpp_week
   626:                  WRITE(numout,*) '   > time scale for ''monthly'' soil temperature (d):', &
   627:                                  pheno_crit%tau_tsoil_month
   628:                  WRITE(numout,*) '   > time scale for ''monthly'' soil humidity (d):', &
   629:                                  pheno_crit%tau_soilhum_month
   630:                  WRITE(numout,*) '   > time scale for vigour calculations (y):', &
   631:                                  pheno_crit%tau_longterm / one_year
   632:            
   633:                ENDIF
   634:            
   635:                !
   636:                ! 30 fraction of allocatable biomass which is lost as growth respiration
   637:                !
   638:            
   639:                IF ( bavard .GE. 1 ) &
   640:                  WRITE(numout,*) '   > growth respiration fraction:', frac_growthresp
   641:            
   642:                !
   643:                ! 31 count number of Stomate-PFTs that correpond to each Sechiba-PFT. Normally result
   644:                !    is 1 for plants, except if we introduce age classes in Stomate and not in Sechiba.
   645:                !
   646:            
   647: +------>       DO j = 1, nvm
   648: |          
   649: |V=====          npft_stomate(j) = COUNT( ipft_sechiba(:) .EQ. j )
   650: |          
   651: |                IF ( bavard .GE. 1 ) &
   652: |                  WRITE(numout,'(a,i2,a,i2,a)') '    > Sechiba-PFT #',j,' corresponds to ',&
   653: |                                                       npft_stomate(j),' Stomate-PFTs.'
   654: |          
   655: +------        ENDDO
   656:            
   657:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving data'
   658:            
   659:              END SUBROUTINE data
   660:            
   661:            END MODULE stomate_data
