Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:43 2008
FILE NAME: i.stomate_deforestation.f90
PROGRAM NAME: stomate_deforestation
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   161  vec  (   4): Vectorized array expression.
   164  vec  (   4): Vectorized array expression.
   196  opt  (1017): Subroutine call prevents optimization.
   206  vec  (   2): Partially vectorized loop.
   206  vec  (  25): Work vectors are used. Size=64byte
   213  vec  (  21): Unvectorizable dependency.
   217  vec  (  21): Unvectorizable dependency.
   228  vec  (   4): Vectorized array expression.
   267  vec  (   4): Vectorized array expression.
   284  vec  (   4): Vectorized array expression.
   301  vec  (   4): Vectorized array expression.
   322  vec  (   4): Vectorized array expression.
   334  vec  (   1): Vectorized loop.
   336  vec  (  26): Macro operation Sum/InnerProd.
   338  vec  (  26): Macro operation Sum/InnerProd.
   350  vec  (   1): Vectorized loop.
   352  vec  (  26): Macro operation Sum/InnerProd.
   354  vec  (  26): Macro operation Sum/InnerProd.
   371  vec  (   4): Vectorized array expression.
   372  opt  (1593): Loop nest collapsed into one loop.
   372  vec  (   4): Vectorized array expression.
   375  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:43 2008
FILE NAME: i.stomate_deforestation.f90
PROGRAM NAME: stomate_deforestation
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            !
     2:            ! update/completion by P. Smith
     3:            !
     4:            
     5:            ! Stomate: deforestation
     6:            !
     7:            ! authors: M. Boisserie, P. Friedlingstein
     8:            !
     9:            ! 
    10:            !
    11:            ! version 0.0: May 2003
    12:            !
    13:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_deforestation.f90,v 1.5 2007/06/13 07:55:43 ssipsl Exp $
    14:            ! IPSL (2006)
    15:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
    16:            !
    17:            MODULE stomate_deforestation
    18:            
    19:            
    20:              ! modules used:
    21:            
    22:              USE ioipsl
    23:              USE stomate_constants
    24:              USE stomate_data
    25:            
    26:              IMPLICIT NONE
    27:            
    28:            
    29:              PRIVATE
    30:              PUBLIC deforestation
    31:            
    32:            CONTAINS
    33:            
    34:              SUBROUTINE deforestation(npts, dt_days, space_nat, space_nat_new,  veget_max, veget_max_new,&
    35:                   biomass, ind, age, PFTpresent, senescence, when_growthinit, everywhere, veget,&        
    36:                   co2_to_bm, bm_to_litter, bm_sapl, tree, cn_ind,flux10,flux100, &
    37:                   prod10,prod100,prod10_total,prod100_total,&
    38:                   convflux,cflux_prod_total,cflux_prod10,cflux_prod100, leaf_frac,&
    39:                   npp_longterm, lm_lastyearmax)
    40:            
    41:                ! 0 declarations
    42:            
    43:                ! 0.1 input
    44:            
    45:                ! Domain size
    46:                INTEGER, INTENT(in)                                            :: npts
    47:            
    48:                ! Time step (days)
    49:                REAL(r_std), INTENT(in)                                         :: dt_days 
    50:            
    51:                ! new "maximal" coverage fraction of a PFT (LAI -> infinity) on nat/agri ground
    52:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)                   :: veget_max_new 
    53:            
    54:                ! biomass of sapling (gC)
    55:                REAL(r_std) , DIMENSION (npft, nparts), INTENT(in)              :: bm_sapl
    56:            
    57:                ! is pft a tree
    58:                LOGICAL, DIMENSION(npft), INTENT(in)                           :: tree
    59:            
    60:            
    61:                ! 0.2 modified fields
    62:            
    63:                ! total natural space (fraction of total space)
    64:                REAL(r_std), DIMENSION(npts), INTENT(inout)                         :: space_nat
    65:            
    66:                ! total natural space (fraction of total space)
    67:                REAL(r_std), DIMENSION(npts), INTENT(in)                         :: space_nat_new
    68:            
    69:                ! fractional coverage on natural/agricultural ground, taking into
    70:                !   account LAI (=grid-scale fpc)
    71:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                    :: veget
    72:            
    73:                ! "maximal" coverage fraction of a PFT (LAI -> infinity) on nat/agri ground
    74:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                    :: veget_max
    75:            
    76:                ! biomass (gC/(m**2 of nat/agri ground))
    77:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)             :: biomass
    78:            
    79:                ! density of individuals 1/m**2
    80:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                    :: ind
    81:            
    82:                ! mean age (years)
    83:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                    :: age
    84:            
    85:                ! is the plant senescent? (only for deciduous trees - carbohydrate reserve)
    86:                !         set to .FALSE. if PFT is introduced or killed
    87:                LOGICAL, DIMENSION(npts,npft), INTENT(inout)                       :: senescence
    88:            
    89:                ! PFT exists
    90:                LOGICAL, DIMENSION(npts,npft), INTENT(inout)                       :: PFTpresent
    91:            
    92:                ! is the PFT everywhere in the grid box or very localized (after its introduction)
    93:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                    :: everywhere
    94:            
    95:                ! how many days ago was the beginning of the growing season
    96:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                    :: when_growthinit
    97:            
    98:                ! biomass uptaken (gC/(m**2 of total ground)/day)
    99:                REAL(r_std), DIMENSION(npts), INTENT(inout)                       :: co2_to_bm
   100:            
   101:                ! conversion of biomass to litter (gC/(m**2 of nat/agri ground)) / day
   102:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)           :: bm_to_litter
   103:            
   104:                ! crown area (m**2) per ind.
   105:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                   :: cn_ind
   106:            
   107:                ! products remaining in the 10/100 year-turnover pool after the annual release for each compartment
   108:                ! (10 or 100 + 1 : input from year of deforestation)
   109:                REAL(r_std), DIMENSION(npts,0:10), INTENT(inout)                     :: prod10
   110:                REAL(r_std), DIMENSION(npts,0:100), INTENT(inout)                    :: prod100
   111:            
   112:                ! annual release from the 10/100 year-turnover pool compartments
   113:                REAL(r_std), DIMENSION(npts,10), INTENT(inout)                     :: flux10
   114:                REAL(r_std), DIMENSION(npts,100), INTENT(inout)                    :: flux100 
   115:            
   116:                ! fraction of leaves in leaf age class
   117:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)         :: leaf_frac
   118:            
   119:                ! last year's maximum leaf mass, for each PFT (gC/(m**2 of nat/agri ground))
   120:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                   :: lm_lastyearmax
   121:            
   122:                ! "long term" net primary productivity (gC/(m**2 of nat/agri ground)/year)
   123:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)                    :: npp_longterm
   124:            
   125:            
   126:                ! 0.3 output
   127:            
   128:                ! release during first year following deforestation
   129:                REAL(r_std), DIMENSION(npts), INTENT(out)                          :: convflux
   130:            
   131:                ! total annual release from the 10/100 year-turnover pool
   132:                REAL(r_std), DIMENSION(npts), INTENT(out)                          :: cflux_prod10, cflux_prod100
   133:            
   134:                ! total products remaining in the pool after the annual release 
   135:                REAL(r_std), DIMENSION(npts), INTENT(out)                          :: prod10_total, prod100_total 
   136:            
   137:                ! total flux from conflux and the 10/100 year-turnover pool 
   138:                REAL(r_std), DIMENSION(npts), INTENT(out)                          :: cflux_prod_total
   139:            
   140:            
   141:                ! 0.4 local
   142:            
   143:                ! indices
   144:                INTEGER(i_std)                                                     :: i, j, k, l, m
   145:            
   146:                ! biomass increase (gC/(m**2 of nat/agri ground))
   147:                REAL(r_std),DIMENSION(npts)                                       :: bm_new
   148:            
   149:                ! change in number of individuals /m2 per year
   150:                REAL(r_std),DIMENSION(npts,npft)                                  :: d_ind 
   151:            
   152:                REAL(r_std)                                                       :: x,above
   153:                REAL(r_std),DIMENSION(npft)                                       :: y,z
   154:            
   155:                REAL(r_std), DIMENSION(npts,npft)                                 :: vegetspace
   156:                REAL(r_std), DIMENSION(npts,npft)                                 :: vegetspace_new    
   157:            
   158:                ! =========================================================================
   159:            
   160:                ! yearly initialisation
   161: V------>       prod10(:,0)           = zero
   162: V------        prod100(:,0)          = zero   
   163:                above                 = zero
   164: V------>       convflux(:)           = zero
   165: |              cflux_prod10(:)       = zero
   166: |              cflux_prod100(:)      = zero
   167: |              prod10_total(:)       = zero
   168: |              prod100_total(:)      = zero
   169: |              cflux_prod_total(:)   = zero
   170: V------        bm_new(:)             = zero
   171:            
   172: +------>       DO i = 1, npts  
   173: |          
   174: |+----->          DO j = 1, npft
   175: ||         
   176: ||                   IF( natural(j) ) THEN
   177: ||         
   178: ||                      vegetspace(i,j) = veget_max(i,j) * space_nat(i)
   179: ||                      vegetspace_new(i,j) = veget_max_new(i,j) * space_nat_new(i)
   180: ||         
   181: ||                   ELSE
   182: ||         
   183: ||                      vegetspace(i,j) = veget_max(i,j) *(1. - space_nat(i))
   184: ||                      vegetspace_new(i,j) = veget_max_new(i,j) *(1. - space_nat_new(i))
   185: ||         
   186: ||                   ENDIF
   187: ||         
   188: ||                   ! in case of establishment of a new PFT or extension of its coverage in a gridcell
   189: ||                   IF ( vegetspace_new(i,j) .GT. vegetspace(i,j)  ) THEN
   190: ||         
   191: ||                      IF ( tree(j) ) THEN
   192: ||         
   193: ||                         IF ( abs(cn_ind(i,j)) > 1e-16) THEN
   194: ||                         d_ind(i,j) =  (vegetspace_new(i,j) - vegetspace(i,j)) / cn_ind (i,j)
   195: ||                         ELSE
   196: ||                            write(numout,*) "deforestation : cn_ind est nul pour i,j = ",i,j
   197: ||                            d_ind(i,j) = zero
   198: ||                         ENDIF
   199: ||         
   200: ||                      ELSE 
   201: ||         
   202: ||                         d_ind(i,j) =  vegetspace_new(i,j) - vegetspace(i,j)
   203: ||         
   204: ||                      ENDIF
   205: ||         
   206: ||V---->                DO k = 1, nparts
   207: |||        
   208: |||                        bm_new(i) = d_ind(i,j) * bm_sapl(j,k)
   209: |||                        biomass(i,j,k) = biomass(i,j,k) + bm_new(i)
   210: |||          
   211: |||     S                  IF( natural(j) ) THEN                  
   212: |||     S  
   213: |||     S                     co2_to_bm(i) = co2_to_bm(i) + bm_new(i) * space_nat_new(i) / one_year * dt_days
   214: |||        
   215: |||                        ELSE
   216: |||        
   217: |||     S                     co2_to_bm(i) = co2_to_bm(i) + bm_new(i) * (1.-space_nat_new(i)) / one_year * dt_days
   218: |||        
   219: |||                        ENDIF
   220: |||        
   221: ||V----                 ENDDO
   222: ||         
   223: ||                      PFTpresent(i,j) = .TRUE.
   224: ||                      everywhere(i,j) = 1.
   225: ||                      senescence(i,j) = .FALSE.
   226: ||                      age(i,j) = 0.
   227: ||                      ind(i,j) = veget_max_new (i,j)
   228: ||V---->                when_growthinit(:,j) = large_value
   229: |||                     leaf_frac(:,j,1) = 1.0
   230: |||                     npp_longterm(:,j) = 10.
   231: ||V----                 lm_lastyearmax(:,j) = bm_sapl(j,ileaf) * ind(:,j)
   232: ||         
   233: ||                   ENDIF   ! End if PFT extension
   234: ||         
   235: ||                   ! in case of total or fractional disparition or a PFT
   236: ||                   IF ( vegetspace_new(i,j) .LT. vegetspace(i,j))     THEN
   237: ||         
   238: ||                      x    = 40./67.
   239: ||                      y(1) = 27./67. 
   240: ||                      y(2) = 27./67. 
   241: ||                      y(9) = 27./67.      
   242: ||                      y(3) = 20./67.
   243: ||                      y(4) = 20./67.
   244: ||                      y(5) = 20./67.  
   245: ||                      y(6) = 20./67.
   246: ||                      y(7) = 20./67.
   247: ||                      y(8) = 20./67. 
   248: ||                      y(10)= 20./67. 
   249: ||                      y(11)= 20./67. 
   250: ||                      z(3) = 7./67. 
   251: ||                      z(4) = 7./67. 
   252: ||                      z(5) = 7./67.
   253: ||                      z(6) = 7./67.
   254: ||                      z(7) = 7./67.
   255: ||                      z(8) = 7./67.
   256: ||                      z(11)= 7./67.
   257: ||                      z(12)= 7./67.
   258: ||                      z(1) = 0.
   259: ||                      z(2) = 0.
   260: ||                      z(9) = 0. 
   261: ||         
   262: ||                      IF ( vegetspace_new(i,j) .EQ. 0. ) THEN
   263: ||         
   264: ||                         IF (.NOT. tree(j) ) THEN 
   265: ||         
   266: ||                            ind(i,j) = 0.0
   267: ||V---->                      bm_to_litter(i,j,:) = bm_to_litter(i,j,:) + biomass(i,j,:) 
   268: ||V----                       biomass(i,j,:) = 0.0             
   269: ||         
   270: ||                         ELSE 
   271: ||         
   272: ||                            ind(i,j) = 0.0
   273: ||                            cn_ind(i,j) = 0.0
   274: ||                            above =  biomass(i,j,1) +  biomass(i,j,2) + &
   275: ||                                 biomass(i,j,4)
   276: ||                            convflux(i)  = convflux(i)  +  x    * above
   277: ||                            prod10(i,0)  = prod10(i,0)  +  y(j) * above
   278: ||                            prod100(i,0) = prod100(i,0) +  z(j) * above
   279: ||                            bm_to_litter(i,j,3) = bm_to_litter(i,j,3) + biomass(i,j,3)
   280: ||                            bm_to_litter(i,j,5) = bm_to_litter(i,j,5) + biomass(i,j,5) 
   281: ||                            bm_to_litter(i,j,6) = bm_to_litter(i,j,6) + biomass(i,j,6)
   282: ||                            bm_to_litter(i,j,7) = bm_to_litter(i,j,7) + biomass(i,j,7)
   283: ||                            bm_to_litter(i,j,8) = bm_to_litter(i,j,8) + biomass(i,j,8)   
   284: ||V====                       biomass(i,j,:) = 0.0
   285: ||         
   286: ||                         ENDIF
   287: ||         
   288: ||                         PFTpresent(i,j) = .FALSE.
   289: ||                         senescence(i,j) = .FALSE.
   290: ||                         age(i,j) = 0.0
   291: ||                         when_growthinit(i,j) = undef
   292: ||                         everywhere(i,j) = 0.0
   293: ||                         veget(i,j) = 0.0
   294: ||         
   295: ||                      ELSE
   296: ||         
   297: ||                         d_ind(i,j) =  vegetspace(i,j) - vegetspace_new(i,j)
   298: ||         
   299: ||                         IF  (.NOT. tree (j))    THEN
   300: ||         
   301: ||V---->                      bm_to_litter(i,j,:) = bm_to_litter(i,j,:) + &
   302: |||                                biomass(i,j,:) * d_ind(i,j) / veget_max(i,j)
   303: ||V----                       biomass(i,j,:) = biomass(i,j,:) * (1. - d_ind(i,j)/veget_max(i,j))
   304: ||                            ind(i,j) = ind(i,j) * (1. - d_ind(i,j))
   305: ||         
   306: ||                         ELSE
   307: ||         
   308: ||                            above =(biomass(i,j,1) + biomass(i,j,2) + biomass(i,j,4)) * d_ind(i,j)/veget_max(i,j)
   309: ||                            convflux(i)  = convflux(i)  + x    * above
   310: ||                            prod10(i,0)  = prod10(i,0)  + y(j) * above
   311: ||                            prod100(i,0) = prod100(i,0) + z(j) * above
   312: ||                            bm_to_litter(i,j,3) = bm_to_litter(i,j,3) + &
   313: ||                                 biomass(i,j,3)* d_ind(i,j)/vegetspace(i,j)
   314: ||                            bm_to_litter(i,j,5) = bm_to_litter(i,j,5) + &
   315: ||                                 biomass(i,j,5)* d_ind(i,j)/vegetspace(i,j)
   316: ||                            bm_to_litter(i,j,6) = bm_to_litter(i,j,6) + &
   317: ||                                 biomass(i,j,6)* d_ind(i,j)/vegetspace(i,j)
   318: ||                            bm_to_litter(i,j,7) = bm_to_litter(i,j,7) +  &
   319: ||                                 biomass(i,j,7)* d_ind(i,j)/vegetspace(i,j)
   320: ||                            bm_to_litter(i,j,8) = bm_to_litter(i,j,8) + &
   321: ||                                 biomass(i,j,8)* d_ind(i,j) /vegetspace(i,j)  
   322: ||V====                       biomass(i,j,:) = biomass(i,j,:) * ( 1. - d_ind(i,j))/vegetspace(i,j) 
   323: ||         
   324: ||                         ENDIF
   325: ||         
   326: ||                      ENDIF   ! End if PFT total disparition
   327: ||         
   328: ||                   ENDIF   ! End if PFT's coverage reduction
   329: ||         
   330: |+-----           ENDDO   ! End loop on PFTs
   331: |          
   332: |                 ! each year, update 10 year-turnover pool content following flux emission
   333: |                 ! (linear decay (10%) of the initial carbon input)
   334: |V----->          DO   l = 0, 8
   335: ||                   m = 10 - l
   336: ||                   cflux_prod10(i) =  cflux_prod10(i) + flux10(i,m)
   337: ||                   prod10(i,m)     =  prod10(i,m-1)   - flux10(i,m-1)
   338: ||                   prod10_total(i) =  prod10_total(i) + prod10(i,m)
   339: ||                   flux10(i,m)     =  flux10(i,m-1)
   340: ||         
   341: ||                   IF (prod10(i,m) .LT. 1.0) prod10(i,m) = 0.0
   342: ||         
   343: |V-----           ENDDO
   344: |          
   345: |                 cflux_prod10(i) = cflux_prod10(i) + flux10(i,1) 
   346: |                 flux10(i,1)     = 0.1 * prod10(i,0)
   347: |                 prod10(i,1)     = prod10(i,0)
   348: |                 prod10_total(i) = prod10_total(i)  + prod10(i,1)
   349: |          
   350: |V----->          DO   l = 0, 98
   351: ||                   m = 100 - l
   352: ||                   cflux_prod100(i)  =  cflux_prod100(i) + flux100(i,m)
   353: ||                   prod100(i,m)      =  prod100(i,m-1)   - flux100(i,m-1)
   354: ||                   prod100_total(i)  =  prod100_total(i) + prod100(i,m)
   355: ||                   flux100(i,m)      =  flux100(i,m-1)
   356: ||         
   357: ||                   IF (prod100(i,m).LT.1.0) prod100(i,m) = 0.0
   358: ||         
   359: |V-----           ENDDO
   360: |          
   361: |                 cflux_prod100(i)  = cflux_prod100(i) + flux100(i,1) 
   362: |                 flux100(i,1)      = 0.01 * prod100(i,0)
   363: |                 prod100(i,1)      = prod100(i,0)
   364: |                 prod100_total(i)  = prod100_total(i) + prod100(i,1)
   365: |                 cflux_prod_total(i) = convflux(i) + cflux_prod10(i) + cflux_prod100(i)
   366: |                 prod10(i,0)        = 0.0
   367: |                 prod100(i,0)       = 0.0 
   368: |          
   369: +------        ENDDO  ! End loop on npts
   370:            
   371: V======        space_nat(:) = space_nat_new(:)
   372: W*=====        veget_max(:,:) = veget_max_new(:,:)
   373:            
   374:                ! convert flux from /year into /time step
   375: V------>       convflux        = convflux/one_year*dt_days
   376: |              cflux_prod10    = cflux_prod10/one_year*dt_days
   377: V------        cflux_prod100   = cflux_prod100/one_year*dt_days
   378:            
   379:              END SUBROUTINE deforestation
   380:            
   381:            END MODULE stomate_deforestation
